#ifndef FLOOR_H
#define FLOOR_H
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <node.h>

typedef struct {
    GdkPixmap *pixmap;
    GtkWidget *drawingArea;
    GList *nodeList;
    GdkGC *bgColor;
    GdkGC *linksColor;
    GdkGC *nodesColor;
    GdkGC *fontColor;
    GdkGC *blackColor;
    GdkGC *whiteColor;
   	
    /* Popup Menus */
    GtkWidget *popUpMenuGeneral;
    GtkWidget *popUpMenuOnNode;
    GtkWidget *popUpMenuOnConnection;
    void *activeNode; /* necessary for menu interaction */
    
    /*these variables are for dragging */
    void *draggingObject;
    gboolean dragging;
    GdkPoint objectDifference;
 
    /*these variables are for connecting */
    void *inputConnection;
    void *outputConnection;
    gboolean connectingToInput;
    gboolean connectingToOutput;
    
    /* for keeping track of the cursor when connecting nodes */
    GdkPoint cursor;

    /* The name of the file currently being used */
    gchar floorFileName[256];
} Floor;

gint add_node_to_floor(Floor *floor);
gint floor_repaint(Floor *floor);
Floor *gui_floor_new();
gint floor_destroy(Floor *floor);
gint floor_save(Floor *floor);
gint floor_save_with_name(Floor *floor,gchar *name);
gint floor_open_with_name(Floor *floor,gchar *name);
gint add_node_to_floor_with_name(Floor *floor, gchar *pluginName);
int add_node_menu_activate(GtkWidget *widget, gpointer data);
void init_nodes_before_connect(Floor *floor);

#endif

