#include <stdio.h>
#include <pthread.h>
#include <unistd.h>
#include <stdlib.h>
#include <gtk/gtk.h>

#include <loop.h>
#include <gui.h>
#include <node.h>
#include <floor.h>
#include <oss.h>

static pthread_t play_thread;
static gboolean pleaseFinish = 0;
static gboolean isSoundcardOpen = FALSE;
int sampling_frequency=44100;
int blocksize=256;
gboolean isThreadRunning = FALSE; 

extern Floor *currentFloor;

int init_loop_on_floor(Floor *floor){
    /* we actually donot need *floor anymore... we'll use
     * *currentFloor instead
     */
    pthread_attr_t play_thread_attr;
    pthread_attr_init(&play_thread_attr);
    /* this can only be done by superuser */
    /*pthread_attr_setschedpolicy(&play_thread_attr,SCHED_FIFO);*/
    if(isThreadRunning==FALSE){
	/* initializing the soundcard */
	if(sound_init_oss(sampling_frequency,&blocksize)!=0){
	    create_message_window("Unable to Initialize Soundcard\n");
	    return -1;
	}
	isSoundcardOpen = TRUE;
	/* start the thread of loop playing */
	if(isThreadRunning==FALSE){
	    pleaseFinish = 0;
	    pthread_create(&play_thread,&play_thread_attr,play_loop_on_floor,(void *)floor);
	    isThreadRunning=TRUE;
	}
    }
    update_light_switch(1);
    return 1;
}

int stop_loop(){
    if(isThreadRunning==TRUE){
	/* nicely ask the thread to stop, and join it */
	pleaseFinish = TRUE;
	pthread_join(play_thread,NULL);
	isThreadRunning = FALSE;
	/* close sound card */
	sound_stop_oss();
	isSoundcardOpen = FALSE;
    } 
    update_light_switch(0);
    return 1;
}

void *play_loop_on_floor(void *data){
    Floor *floor;
    short int **buffers;
    short int *buffer;
    floor = (Floor *)data;
    buffers = (short int **)calloc(sizeof(short int *),3);
    buffer = (short int *)calloc(sizeof(short int),blocksize);
    buffers[0] = buffer;
    while(pleaseFinish!=TRUE){
	/*
	 * HERE GOES THE MAGNA MAGNAGNA 
	 */
	sound_read_oss(buffers[0],blocksize);
	/* before connecting everything together, initialize the
	 * nodes, get the babies ready.
	 */
	init_nodes_before_connect(currentFloor);
	propagate_processing_from(get_main_input_node(currentFloor),buffers);
    }
    /* clean up */
    free(buffer);
    free(buffers);
    pleaseFinish = FALSE;
    return 0;
}

void propagate_processing_from(Node *node,short int **buffers){
    process_node(node,buffers); 
}
