#include <gtk/gtk.h>
#include <dlfcn.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>
#include <stdio.h>

#include <plugin.h>
#include <pluginmanager.h>
#include <node.h>

#ifndef PLUGINS_PATH
#define PLUGINS_PATH "/home/urtubia/projects/stompboxes2/plugins"
#endif

int number_of_found_plugins;

gchar *get_plugin_name(gchar *filename)
{
    gchar fullfilename[256]=PLUGINS_PATH;
    static gchar pname[256];
    void *handle;
    Plugin *plugininfo;
    Plugin *(*get_plugin_info)(void);

    if(strcmp(&filename[strlen(filename) - 2], "so")){
	/*fprintf(stderr,"Does not end with so\n");*/
	return NULL;
    }
    strcat(fullfilename, "/");
    strcat(fullfilename, filename);
    if((handle=dlopen(fullfilename, RTLD_NOW)) == NULL){
	/*fprintf(stderr,"Couldn't open as a shared library\n");*/
	return NULL;
    }
    
    if((get_plugin_info=dlsym(handle, "get_plugin_info")) != NULL)
    {
	/*fprintf(stderr,"%s seems to be a plugin\n",filename);*/
	plugininfo=get_plugin_info();
	strcpy(pname, plugininfo->name);
	dlclose(handle);
	return pname;
    }
    /*fprintf(stderr,"no get_plugin_info function on
     * %s\n",filename);*/
    dlclose(handle);
    return NULL;
}


void find_all_plugins(GtkWidget *list)
{
    DIR *dp;
    struct dirent *wpis;
    struct stat statbufor;
    gchar *list_row[2];

    number_of_found_plugins=0;
    if((dp=opendir(PLUGINS_PATH)) == NULL) return;
    chdir(PLUGINS_PATH);

    while((wpis=readdir(dp)) != NULL)
    {
	stat(wpis->d_name, &statbufor);
	if(S_ISREG(statbufor.st_mode))
	{
	    /*fprintf(stderr,"Seeing if %s is a valid plugin\n",wpis->d_name);*/
	    list_row[1]=get_plugin_name(wpis->d_name);
	    if(list_row[1] != NULL)
	    {
		list_row[0]=wpis->d_name;
		gtk_clist_append(GTK_CLIST(list), list_row);
		number_of_found_plugins++;
	    }
	}
    }

    closedir(dp);
}

/*
GList * get_plugin_list(){

}
*/
